﻿using System;

using Npgsql;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Title = "PostgreSQL 데이터베이스 사용하기";

            string connectionString = "Host=127.0.0.1;Port=5432;Database=testdb;User ID=postgres;Password=1234";

            using(NpgsqlConnection connection = new NpgsqlConnection(connectionString))
            {
                try
                {
                    connection.Open();

                    using(NpgsqlCommand command = new NpgsqlCommand())
                    {
                        command.Connection  = connection;
                        command.CommandText = "SELECT * FROM student";
 
                        using(NpgsqlDataReader reader = command.ExecuteReader())
                        {
                            while(reader.Read())
                            {
                                Console.WriteLine
                                (
                                    $"id={reader.GetInt32(0)}|name={reader.GetString(1)}|age={reader.GetFieldValue<int?>(2)}"
                                );
                            }
                        }
                    }
                }
                catch(Exception exception)
                {
                    Console.WriteLine(exception.ToString());
                }
            }
        }

        #endregion
    }
}